from Products.validation.interfaces import ivalidator

class CoursesValidator:

    __implements__ = (ivalidator,)

    def __init__(self, name):
        self.name = name

# username, year, month, day, hours, minuts, duration_minutes, recurrence_interval, 
# start_year, start_month, start_day, end_year, end_month, end_day, course_name, red, green, blue
    def __call__(self, value, *args, **kwargs):
        self.lines = {'username'            : [],
                      'year'                : [],
                      'month'               : [],
                      'day'                 : [],
                      'hour'                : [],
                      'minute'              : [],
                      'duration_minutes'    : [],
                      'recurrence_interval' : [],
                      'start_year'          : [],
                      'start_month'         : [],
                      'start_day'           : [],
                      'end_year'            : [],
                      'end_month'           : [],
                      'end_day'             : [],
                      'course_name'         : [],
                      'red'                 : [],
                      'green'               : [],
                      'blue'                : []}
                  
        # setup and check for item count errors:

        line_errors = []
        line_count = 1
        for course_string in value:
            username = ""
            year = ""
            month = ""
            day = ""
            hour = ""
            minute = ""
            duration_minutes = ""
            recurrence_interval = ""
            start_year = ""
            start_month = ""
            start_day = ""
            end_year = ""
            end_month = ""
            end_day = ""
            course_name = ""
            red = ""
            green = ""
            blue = ""
            try:
                items = eval('[%s]' % course_string)
            except:
                return "Mixed numeric and text input somewhere on line %d" % line_count
            if len(items) != 18:
                line_errors.append("%d" % line_count)
            else:
                username, year, month, day, hour, minute, duration_minutes, recurrence_interval, start_year, start_month, start_day, end_year, end_month, end_day, course_name, red, green, blue = items 
                self.lines['username'].append(username)
                self.lines['year'].append(year)
                self.lines['month'].append(month)
                self.lines['day'].append(day)
                self.lines['hour'].append(hour)
                self.lines['minute'].append(minute)
                self.lines['duration_minutes'].append(duration_minutes)
                self.lines['recurrence_interval'].append(recurrence_interval)
                self.lines['start_year'].append(start_year)
                self.lines['start_month'].append(start_month)
                self.lines['start_day'].append(start_day)
                self.lines['end_year'].append(end_year)
                self.lines['end_month'].append(end_month)
                self.lines['end_day'].append(end_day)
                self.lines['course_name'].append(course_name)
                self.lines['red'].append(red)
                self.lines['green'].append(green)
                self.lines['blue'].append(blue)
            line_count += 1
        if len(line_errors) > 0:
            return "Wrong number of items on lines: %s" % line_errors

        # check for basic conversion errors:

        error_message = ""
        errors = None

        errors = self.checkForUsernameErrors()
        if errors:
            error_message = "username (field 1) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForYearErrors()
        if errors:
            error_message = "year (field 2) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForMonthErrors()
        if errors:
            error_message = "month (field 3) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForDayErrors()
        if errors:
            error_message = "day (field 4) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForHourErrors()
        if errors:
            error_message = "hour (field 5) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForMinuteErrors()
        if errors:
            error_message = "minute (field 6) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForDurationMinutesErrors()
        if errors:
            error_message = "duration_minutes (field 7) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForRecurrenceIntervalErrors()
        if errors:
            error_message = "recurrence_interval (field 8) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForStartYearErrors()
        if errors:
            error_message = "start_year (field 9) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForStartMonthErrors()
        if errors:
            error_message = "start_month (field 10) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForStartDayErrors()
        if errors:
            error_message = "start_day (field 11) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForEndYearErrors()
        if errors:
            error_message = "end_year (field 12) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForEndMonthErrors()
        if errors:
            error_message = "end_month (field 13) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForEndDayErrors()
        if errors:
            error_message = "end_day (field 14) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForCourseNameErrors()
        if errors:
            error_message = "course_name (field 15) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForRedErrors()
        if errors:
            error_message = "Red (field 16) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForGreenErrors()
        if errors:
            error_message = "Green (field 17) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForBlueErrors()
        if errors:
            error_message = "Blue (field 18) error on lines: %s" % str(errors)
            return error_message

        # check for start and end time range errors:
        error_message = ""

        # check for color range errors:
        errors = self.checkForColorRangeErrors()
        if errors:
            error_message = "One or more color values out of range (0-255) on lines: %s" % str(errors)
            return error_message

        return 1

    def checkForYearErrors(self):
        line_errors = []
        count = 1
        for year in self.lines['year']:
            try:
                int(year)
            except:
                line_errors.append(count)
            if int(year) < 0:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForMonthErrors(self):
        line_errors = []
        count = 1
        for month in self.lines['month']:
            try:
                int(month)
            except:
                line_errors.append(count)
            if int(month) < 0 or int(month) > 12:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForDayErrors(self):
        line_errors = []
        count = 1
        for day in self.lines['day']:
            try:
                int(day)
            except:
                line_errors.append(count)
            if int(day) < 0 or int(day) > 31:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForHourErrors(self):
        line_errors = []
        count = 1
        for hour in self.lines['hour']:
            try:
                int(hour)
            except:
                line_errors.append(count)
            if int(hour) < 0 or int(hour) > 23:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForMinuteErrors(self):
        line_errors = []
        count = 1
        for minute in self.lines['minute']:
            try:
                int(minute)
            except:
                line_errors.append(count)
            if int(minute) < 0 or int(minute) > 59:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForDurationMinutesErrors(self):
        line_errors = []
        count = 1
        for duration_minute in self.lines['duration_minutes']:
            try:
                int(duration_minute)
            except:
                line_errors.append(count)
            if int(duration_minute) < 0:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForStartYearErrors(self):
        line_errors = []
        count = 1
        for start_year in self.lines['start_year']:
            try:
                int(start_year)
            except:
                line_errors.append(count)
            if int(start_year) < 0:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForStartMonthErrors(self):
        line_errors = []
        count = 1
        for start_month in self.lines['start_month']:
            try:
                int(start_month)
            except:
                line_errors.append(count)
            if int(start_month) < 0 or int(start_month) > 12:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForStartDayErrors(self):
        line_errors = []
        count = 1
        for start_day in self.lines['start_day']:
            try:
                int(start_day)
            except:
                line_errors.append(count)
            if int(start_day) < 0 or int(start_day) > 31:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForEndYearErrors(self):
        line_errors = []
        count = 1
        for end_year in self.lines['end_year']:
            try:
                int(end_year)
            except:
                line_errors.append(count)
            if int(end_year) < 0:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForEndMonthErrors(self):
        line_errors = []
        count = 1
        for end_month in self.lines['end_month']:
            try:
                int(end_month)
            except:
                line_errors.append(count)
            if int(end_month) < 0 or int(end_month) > 12:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForEndDayErrors(self):
        line_errors = []
        count = 1
        for end_day in self.lines['end_day']:
            try:
                int(end_day)
            except:
                line_errors.append(count)
            if int(end_day) < 0 or int(end_day) > 31:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForUsernameErrors(self):
        # pass
        return None

    def checkForRecurrenceIntervalErrors(self):
        line_errors = []
        count = 1
        choices = ['DAILY', 'WEEKLY', 'MONTHLY']
        for recurrence_interval in self.lines['recurrence_interval']:
            if recurrence_interval not in choices:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForCourseNameErrors(self):
        # pass
        return None

    def checkForColorErrors(self, color_name):
        line_errors = []
        count = 1
        for color in self.lines[color_name]:
            try:
                int(color)
            except:
                line_errors.append(count)
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForRedErrors(self):
        return self.checkForColorErrors('red')

    def checkForGreenErrors(self):
        return self.checkForColorErrors('green')

    def checkForBlueErrors(self):
        return self.checkForColorErrors('blue')

    def checkForColorRangeErrors(self):
        line_errors = []
        for i in range(len(self.lines['red'])):
            red = int(self.lines['red'][i])
            green = int(self.lines['green'][i])
            blue = int(self.lines['blue'][i])

            # must be between 0 and 255
            if red < 0 or red > 255 or green < 0 or green > 255 or blue < 0 or blue > 255:
                line_errors.append(i+1)
        if len(line_errors) > 0:
            return line_errors
        return None

