# Version 0.1
#
#  TeachingSchedule is copyright 2005 Jeffrey G. Pittman.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#  MA 02111-1307 USA

try :
    from reportlab.lib import colors as rlcolors
except ImportError :
    from reportlab.lib import colors as rlcolors

def getrlcolor(red, green, blue):
    if red > 255:
        red = 255
    if green > 255:
        green = 255
    if blue > 255:
        blue = 255

    if red > 0:
        red = float(red)/255.0
    else:
        red = 0.0
    if green > 0:
        green = float(green)/255.0
    else:
        green = 0.0
    if blue > 0:
        blue = float(blue)/255.0
    else:
        blue = 0.0
    return rlcolors.Color(red, green, blue)

def colorstr(rgb):
    """
    from http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/325823
    """
    return "#%x%x%x" % (rgb[0]/16,rgb[1]/16,rgb[2]/16)

def rgb256(color):
    """
    reportlab.lib.colors.rgb() returns a three tuple of percentages,
    but we need the values as 0-255
    """
    r,g,b = color

    return (int(r*255.0), int(g*255.0), int(b*255.0))

def wordWrap(text, width):
    """
    This method is from
    http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/148061
    A word-wrap function that preserves existing line breaks
    and most spaces in the text. Expects that existing line
    breaks are posix newlines (\n).
    """
    return reduce(lambda line, word, width=width: '%s%s%s' %
                  (line,
                   ' \n'[(len(line)-line.rfind('\n')-1
                         + len(word.split('\n',1)[0]
                              ) >= width)],
                   word),
                  text.split(' ')
                 )



